package cpcns.dingZhi.zhuanHuanGongJu.controller;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cpcns.base.common.BaseException;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.generic.ResultMessage;
import cpcns.dangAnBase.base.controller.DangAnBaseController;
import cpcns.dingZhi.zhuanHuanGongJu.model.ZhuanHuanGongJu;
import cpcns.dingZhi.zhuanHuanGongJu.service.ZhuanHuanGongJuService;
import cpcns.gongyongzujian.dianzidangan.util.FuJianPathUtils;
import cpcns.utils.CommStatic;
import cpcns.utils.JpgToPdfUtil;
import cpcns.utils.PagerVO;
import cpcns.utils.TifToPdfUtil;
import cpcns.utils.YinPinToWAV;
import cpcns.utils.ZipUtil;
import cpcns.utils.shiPinToAVI;
import cpcns.utils.tiffToJPEG;
import cpcns.utils.tool;
import cpcns.utils.tuPaiToJPG;
import cpcns.utils.wordOrExcelToPdfUtil;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.UUID;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

@Controller
@RequestMapping({"/zhuanHuanGongJu"})
public class zhuanHuanGongJuController extends DangAnBaseController {
  @Autowired
  private ZhuanHuanGongJuService zhuanHuanGongJuService;
  
  @RequestMapping({"/list.do"})
  public ModelAndView execute(HttpServletRequest request) throws Exception {
    ModelAndView mv = new ModelAndView("/dingZhi/zhuanHuanGongJu/zhuanHuan_List");
    return mv;
  }
  
  @RequestMapping({"/query.do"})
  public String query(HttpServletRequest request, HttpServletResponse response, Model model) {
    try {
      Map<String, Object> map = tool.getRequestParamsMaps(request);
      String page = request.getParameter("page");
      String rows = request.getParameter("rows");
      int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
      int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
      int start = (intPage - 1) * number;
      PagerVO pagevo = this.zhuanHuanGongJuService.query_SQL(Integer.valueOf(start), Integer.valueOf(number), "D_ZHUANHUANJILU", map, CommStatic.getOrderBy(request, "jieSuShiJian asc"));
      String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo).replaceAll(" 00:00:00", "").replaceAll(":00", "").replaceAll("", "").replaceAll("HANGBIAOSHI", "hangBiaoShi")
        .replaceAll("ZHUANHUANLEIXING", "zhuanHuanLeiXing").replaceAll("YUANWENJIANMING", "yuanWenJianMing").replaceAll("YUANWENJIANGESHI", "yuanWenJianGeShi")
        .replaceAll("ZHUANHUANWENJIANMING", "zhuanHuanWenJianMing").replaceAll("ZHUANHUANXINWENJIANMING", "zhuanHuanXingWenJianMing")
        .replaceAll("ZHUANHUANWENJIANGESHI", "zhuanHuanWenJianGeShi").replaceAll("ZHUANHUANWENJIANLUJING", "zhuanHuanWenJianLuJing").replaceAll("ZHUANHUANRENBIAOSHI", "zhuanHuanRenBiaoShi")
        .replaceAll("ZHUANHUANRENMINGCHENG", "zhuanHuanRenMingCheng").replaceAll("KAISHISHIJIAN", "kaiShiShiJian").replaceAll("JIESUSHIJIAN", "jieSuShiJian").replaceAll("ZHUANHUANYONGSHI", "zhuanHuanYongShi")
        .replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("ZHUANHUANMIAOSHU", "zhuanHuanMiaoShu").replaceAll("BEIZHU", "beiZhu").replaceAll("BEIYONGZI", "beiYongZi").replaceAll("BEIYONGZIFU", "beiYongZiFu");
      write(response, jsonString);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  @RequestMapping({"/openZhuanHuan"})
  public ModelAndView openZhuanHuan_view() {
    ModelAndView mv = new ModelAndView("/dingZhi/zhuanHuanGongJu/zhuanHuan_view");
    return mv;
  }
  
  @RequestMapping({"/zhuanHuanFile"})
  @ResponseBody
  public void zhuanHuanFile(@RequestParam(value = "fileData", required = false) MultipartFile file, HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    if (file != null) {
      try {
        ZhuanHuanGongJu zhgj = new ZhuanHuanGongJu();
        zhgj.setKaiShiShiJian(new Date());
        String geShi = getRequest().getParameter("geShi");
        String yuanWenJianMing = file.getOriginalFilename().replaceAll("#", "_").replaceAll("&", "_").replaceAll("=", "_").replaceAll("[+]", "_").replaceAll("%", "_").replaceAll("[?]", "_").replaceAll("？", "_");
        String houZhui = yuanWenJianMing.substring(yuanWenJianMing.lastIndexOf(".") + 1);
        Date date = new Date(System.currentTimeMillis());
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");
        String yhrsfm = simpleDateFormat.format(date);
        String fileName = yhrsfm;
        String path = "templatePath" + File.separator + yhrsfm + "_" + UUID.randomUUID() + File.separator;
        String url = String.valueOf(request.getScheme()) + "://" + request.getServerName() + ":" + request.getServerPort() + "/CPCNS0412_DianZiDangAn/CPCNS/upload/" + path.replace("\\", "/");
        String filePath = FuJianPathUtils.obtainCiPanPath(path);
        File fileFolder = new File(filePath);
        if (!fileFolder.exists())
          fileFolder.mkdirs(); 
        String inputFile = String.valueOf(filePath) + yuanWenJianMing;
        file.transferTo(new File(String.valueOf(filePath) + yuanWenJianMing));
        System.out.println("文件已上传成功：");
        boolean result = false;
        String outputFile = "";
        String miaoShu = "";
        if (geShi.equals("pdf")) {
          zhgj.setZhuanHuanLeiXing(Integer.valueOf(2));
          zhgj.setYuanWenJianGeShi(houZhui);
          zhgj.setZhuanHuanWenJianMing(fileName);
          outputFile = String.valueOf(filePath) + fileName + ".pdf";
          if (houZhui.equalsIgnoreCase("doc") || houZhui.equalsIgnoreCase("docx")) {
            result = wordOrExcelToPdfUtil.doc2pdf(inputFile, outputFile);
          } else if (houZhui.equalsIgnoreCase("xls") || houZhui.equalsIgnoreCase("xlsx")) {
            result = wordOrExcelToPdfUtil.excel2pdf(inputFile, outputFile);
          } else if (houZhui.equalsIgnoreCase("tif")) {
            result = TifToPdfUtil.tifToPdf(inputFile, outputFile);
          } else if (houZhui.equalsIgnoreCase("jpg") || houZhui.equalsIgnoreCase("png")) {
            result = JpgToPdfUtil.imgToPdf(inputFile, outputFile);
          } else {
            miaoShu = "暂不支持的转换格式，请重新选择文件或格式！";
          } 
          if (result) {
            url = String.valueOf(url) + fileName + ".pdf";
          } else {
            System.out.println("文件转换pdf失败！");
            miaoShu = "文件转换pdf失败！";
          } 
        } else if (geShi.equals("avi") || geShi.equals("flv") || geShi.equals("mp4") || geShi.equals("mpg") || geShi.equals("mxf")) {
          if (geShi.equals("avi")) {
            zhgj.setZhuanHuanLeiXing(Integer.valueOf(3));
          } else if (geShi.equals("flv")) {
            zhgj.setZhuanHuanLeiXing(Integer.valueOf(6));
          } else if (geShi.equals("mp4")) {
            zhgj.setZhuanHuanLeiXing(Integer.valueOf(7));
          } else if (geShi.equals("mpg")) {
            zhgj.setZhuanHuanLeiXing(Integer.valueOf(8));
          } else if (geShi.equals("mxf")) {
            zhgj.setZhuanHuanLeiXing(Integer.valueOf(9));
          } 
          zhgj.setYuanWenJianGeShi(houZhui);
          zhgj.setZhuanHuanWenJianMing(fileName);
          if (houZhui.equalsIgnoreCase("mpg") || houZhui.equalsIgnoreCase("mpeg") || houZhui.equalsIgnoreCase("wmv") || houZhui.equalsIgnoreCase("3gp") || houZhui.equalsIgnoreCase("mov") || houZhui.equalsIgnoreCase("mp4") || houZhui.equalsIgnoreCase("asf") || houZhui.equalsIgnoreCase("asx") || houZhui.equalsIgnoreCase("flv") || houZhui.equalsIgnoreCase("vob") || houZhui.equalsIgnoreCase("vob") || houZhui.equalsIgnoreCase("wmv9") || houZhui.equalsIgnoreCase("rm") || houZhui.equalsIgnoreCase("rmvb") || houZhui.equalsIgnoreCase("mxf")) {
            outputFile = String.valueOf(filePath) + fileName + "." + geShi;
            result = shiPinToAVI.doConvert(inputFile, filePath, String.valueOf(fileName) + "." + geShi).booleanValue();
            if (result) {
              url = String.valueOf(url) + fileName + ".avi";
            } else {
              miaoShu = "视频转换失败，请联系系统管理员！";
            } 
          } else {
            miaoShu = "暂不支持的转换格式，请重新选择文件或格式！";
          } 
          zhgj.setZhuanHuanWenJianGeShi(geShi);
        } else if (geShi.equals("jpg")) {
          zhgj.setZhuanHuanLeiXing(Integer.valueOf(1));
          zhgj.setYuanWenJianGeShi(houZhui);
          zhgj.setZhuanHuanWenJianMing(fileName);
          if (houZhui.equalsIgnoreCase("bmp")) {
            outputFile = String.valueOf(filePath) + fileName + ".jpg";
            result = tuPaiToJPG.bmpTojpg(inputFile, outputFile).booleanValue();
            if (result) {
              url = String.valueOf(url) + fileName + ".jpg";
            } else {
              System.out.println("文件转换jpg失败！");
              miaoShu = "文件转换jpg失败！";
            } 
          } else if (houZhui.equalsIgnoreCase("png")) {
            outputFile = String.valueOf(filePath) + fileName + ".jpg";
            result = tuPaiToJPG.pngToJpg(inputFile, outputFile).booleanValue();
            if (result) {
              url = String.valueOf(url) + fileName + ".jpg";
            } else {
              System.out.println("文件转换png失败！");
              miaoShu = "文件转换png失败！";
            } 
          } else if (houZhui.equalsIgnoreCase("gif")) {
            outputFile = String.valueOf(filePath) + "gif" + File.separator;
            File filegif = new File(outputFile);
            if (!filegif.exists())
              filegif.mkdirs(); 
            result = tuPaiToJPG.gifTojpg(inputFile, outputFile).booleanValue();
            if (result) {
              String zipPath = String.valueOf(outputFile.substring(0, outputFile.length() - 1)) + ".zip";
              try {
                ZipUtil.packToolFiles(outputFile, zipPath);
                outputFile = zipPath;
              } catch (Exception e) {
                e.printStackTrace();
                result = false;
              } 
            } else {
              System.out.println("文件转换gif失败！");
              miaoShu = "文件转换gif失败！";
            } 
          } else if (houZhui.equalsIgnoreCase("tif")) {
            outputFile = String.valueOf(filePath) + fileName + ".jpg";
            result = tiffToJPEG.tiffToJPEG(inputFile, outputFile).booleanValue();
            if (result) {
              url = String.valueOf(url) + fileName + ".jpg";
            } else {
              System.out.println("文件转换png失败！");
              miaoShu = "文件转换png失败！";
            } 
          } else {
            miaoShu = "暂不支持的转换格式，请重新选择文件或格式！";
          } 
          zhgj.setZhuanHuanWenJianGeShi(geShi);
        } else if (geShi.equals("wav")) {
          zhgj.setZhuanHuanLeiXing(Integer.valueOf(4));
          zhgj.setYuanWenJianGeShi(houZhui);
          zhgj.setZhuanHuanWenJianMing(fileName);
          if (houZhui.equalsIgnoreCase("mp3")) {
            outputFile = String.valueOf(filePath) + fileName + ".wav";
            result = YinPinToWAV.YPToALL(inputFile, outputFile, "wav");
            if (result) {
              url = String.valueOf(url) + fileName + ".wav";
            } else {
              miaoShu = "视频转换失败，请联系系统管理员！";
            } 
          } else {
            miaoShu = "暂不支持的转换格式，请重新选择文件或格式！";
          } 
          zhgj.setZhuanHuanWenJianGeShi(geShi);
        } else if (geShi.equals("ofd")) {
          zhgj.setZhuanHuanLeiXing(Integer.valueOf(5));
          zhgj.setYuanWenJianGeShi(houZhui);
          zhgj.setZhuanHuanWenJianMing(fileName);
          outputFile = String.valueOf(filePath) + fileName + ".ofd";
          String pdfFile = String.valueOf(filePath) + fileName + ".pdf";
          if (houZhui.equalsIgnoreCase("doc") || houZhui.equalsIgnoreCase("docx")) {
            result = wordOrExcelToPdfUtil.doc2pdf(inputFile, pdfFile);
            if (result) {
              File yflie = new File(pdfFile);
              yflie.renameTo(new File(outputFile));
              url = String.valueOf(url) + fileName + ".ofd";
            } 
          } else if (houZhui.equalsIgnoreCase("xls") || houZhui.equalsIgnoreCase("xlsx")) {
            result = wordOrExcelToPdfUtil.excel2pdf(inputFile, pdfFile);
            if (result) {
              File yflie = new File(pdfFile);
              yflie.renameTo(new File(outputFile));
              url = String.valueOf(url) + fileName + ".ofd";
            } 
          } else if (houZhui.equalsIgnoreCase("tif")) {
            result = TifToPdfUtil.tifToPdf(inputFile, pdfFile);
            if (result) {
              File yflie = new File(pdfFile);
              yflie.renameTo(new File(outputFile));
              url = String.valueOf(url) + fileName + ".ofd";
            } 
          } else if (houZhui.equalsIgnoreCase("jpg") || houZhui.equalsIgnoreCase("png")) {
            result = JpgToPdfUtil.imgToPdf(inputFile, pdfFile);
            if (result) {
              File yflie = new File(pdfFile);
              yflie.renameTo(new File(outputFile));
              url = String.valueOf(url) + fileName + ".ofd";
            } 
          } else if (houZhui.equalsIgnoreCase("pdf") || houZhui.equalsIgnoreCase("PDF")) {
            File yflie = new File(inputFile);
            yflie.renameTo(new File(outputFile));
            url = String.valueOf(url) + fileName + ".ofd";
            result = true;
          } else {
            miaoShu = "暂不支持的转换格式，请重新选择文件或格式！";
          } 
          zhgj.setZhuanHuanWenJianGeShi(geShi);
        } 
        rm.setSuccess(result);
        rm.setInfo(outputFile);
        zhgj.setHangBiaoShi(Integer.valueOf(this.zhuanHuanGongJuService.getPk("D_ZHUANHUANJILU")));
        zhgj.setZhuanHuanRenBiaoShi(getUser().getBiaoShi());
        zhgj.setZhuanHuanRenMingCheng(getUser().getMingCheng());
        zhgj.setYuanWenJianMing(yuanWenJianMing);
        if (result) {
          zhgj.setZhuangTai(Integer.valueOf(1));
        } else {
          zhgj.setZhuangTai(Integer.valueOf(2));
        } 
        zhgj.setZhuanHuanWenJianLuJing(outputFile);
        zhgj.setZhuanHuanMiaoShu(miaoShu);
        zhgj.setJieSuShiJian(new Date());
        this.zhuanHuanGongJuService.save(zhgj);
      } catch (IOException e) {
        e.printStackTrace();
        rm.setSuccess(false);
        rm.setInfo("转换文件失败！");
      } 
    } else {
      System.out.println("------------上传文件为空----------zhuanHuanGongJu/openZhuanHuan_view.do");
      rm.setSuccess(false);
      rm.setInfo("上传文件为空！");
    } 
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/xiaZai"})
  private void xiaZai(HttpServletResponse response) {
    String filePath = getRequest().getParameter("filePath");
    File f = new File(filePath);
    if (f.exists()) {
      byte[] b = (byte[])null;
      InputStream inputStream = null;
      OutputStream outputStream = null;
      try {
        InputStream in = new FileInputStream(f);
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        byte[] temp = new byte[1024];
        int size = 0;
        while ((size = in.read(temp)) != -1)
          out.write(temp, 0, size); 
        b = out.toByteArray();
        inputStream = new ByteArrayInputStream(b);
        response.setContentType("application/download");
        response.setCharacterEncoding("UTF-8");
        response.setHeader("Content-Disposition", "attachment;fileName=" + f.getName());
        ServletOutputStream servletOutputStream = response.getOutputStream();
        int i = 0;
        byte[] buffer = new byte[1024];
        if (inputStream != null) {
          while ((i = inputStream.read(buffer)) != -1)
            servletOutputStream.write(buffer, 0, i); 
          inputStream.close();
          servletOutputStream.flush();
          servletOutputStream.close();
        } 
        out.close();
        in.close();
      } catch (IOException e) {
        e.printStackTrace();
      } 
    } 
  }
  
  public void responseWriter(HttpServletResponse response, String responseData) {
    PrintWriter out = null;
    try {
      String contentType = "text/html;charset=UTF-8";
      response.setContentType(contentType);
      out = response.getWriter();
      out.write(responseData);
    } catch (IOException e) {
      throw new BaseException(e);
    } finally {
      if (out != null) {
        out.flush();
        out.close();
      } 
    } 
  }
}
